/**
 *  Copyright (c) 2021, Texas Instruments Incorporated
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  *   Redistributions of source code must retain the above copyright
 *  notice, this list of conditions and the following disclaimer.
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  *   Neither the name of Texas Instruments Incorporated nor the names of
 *  its contributors may be used to endorse or promote products derived
 *  from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 *  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

import { Prop, Component, Element } from '@stencil/core';
import { AevmGpioCodec } from '../gc-codec-aevm-gpio/lib/AevmGpioCodec';
import { GcCodecBaseProps } from '../gc-target-configuration/gc-codec-base-props';
import { GcCodecGpioBaseProps } from '../gc-target-configuration/gc-codec-gpio-base-props';
import { createTargetParamsProxy } from '../gc-target-device-programmable/TargetDeviceParamsProxy';

/**
 * `gc-codec-aevm-gpio` is a non visual component for GPIO interface for Analog EVM.
 * Add one or more `gc-codec-aevm-gpio` components to this component to represent individual GPIO pins.
 *
 * @usage
 * @label AEVM GPIO Codec
 * @group Transports, Models, and Codecs
 * @isContainer
 */
@Component({
    tag: 'gc-codec-aevm-gpio',
    shadow: true
})

export class GcCodecAevmGpio implements GcCodecGpioBaseProps, GcCodecBaseProps {
    private impl: AevmGpioCodec | undefined;

    connectedCallback() {
        this.impl = new AevmGpioCodec(new Proxy(createTargetParamsProxy(this.el), {
            get: function(target1, prop1) {
                if (prop1 === 'pins') {
                    return target1.children;
                }
                return target1[prop1];
            }
        }));
    }

    disconnectedCallback() {
        this.impl.dispose();
    }

    // #region gc-target-configuration/gc-codec-gpio-base-props.tsx:
    // -----------Autogenerated - do not edit--------------
    /**
     * Refresh interval in milliseconds. Used for polling the states of input pins.
     *
     * @order 61
     */
    @Prop() refereshInterval = 100;
    // #endregion
    // #region gc-target-configuration/gc-codec-base-props.tsx:
    // -----------Autogenerated - do not edit--------------
    /**
     * A flag indicating that this model, transport, codec, or device is not necessary for connecting
     * to the target.  Any failure should not prevent the connection from continuing, which may
     * result in a partial connection.
     *
     * @order 77
     */
    @Prop() optional: boolean = false;

    /**
     * An optional identifier of a target device that is associated with this model, transport or codec.
     * Specifying a target device indicates that this component is necessary and/or optional for
     * properly connecting to the target device.  If a required component fails to connect, other components
     * will not be connected that are associated with the same device by id.  This way you can associate
     * a gc-target-program-loader with a gc-transport-usb so that if the program fails to load the transport
     * will not attempt to connect and will fail, unless the gc-target-program-loader has the optional property
     * set.  The absence of a target device indicates this is necessary and/or optional
     * for connecting to any device.  As a result, specifying the deviceId is not necessary if you only have
     * one device in you target configuration, any failure to connect will result in the entire connection
     * being aborted.
     *
     * @order 80
     */
    @Prop() deviceId: string;

    @Element() el: HTMLElement;
    // #endregion

}
